do
	--TODO: generic collision base class?
	XPRACTICE.THEJAILER2.Collision = {}
	local class=XPRACTICE.THEJAILER2.Collision
	class.__index = class

	function class.new(scenario)
		local self=setmetatable({}, class)
		self.scenario=scenario
		return self 
	end


	function class:OutOfBoundsCheck()
		local scenario=self.scenario
		if(not scenario.player)then return end

		if(scenario.player.position.z<-60)then	--TODO: determine most-appropriate height for death plane
			-- pally bubble can't save you here				
			scenario:AttemptKillPlayer(scenario.player,true)
			scenario.statuslabel:SetText("Fell off the arena.",3.0)
			local args={}				
			--TODO NEXT: further checks for context: off the sides? into hole? jumped too early with rune?
				-- "0": context unknown, "1" sides, "2" hole, "3" early
			tinsert(args,"0")						
			scenario.multiplayer:FormatAndSendCustom("DEAD_RINGOUT",unpack(args))
			local player=scenario.player				
			local auras=player.combatmodule.auras:GetAurasByClassIfExistIncludingNewAuras(XPRACTICE.THEJAILER2.Aura_ExplosiveRunes)	
			for i=1,#auras do
				auras[i]:OnRemove()
			end
			player.position={x=7.27,y=37.71,z=2}
			player.velocity={x=0,y=0,z=0}	--TODO NEXT: other scenarios need low framerate fix too
		end
	
		for k,v in pairs(scenario.multiplayer.allplayers)do
			local player=v
			if(player~=scenario.player)then
				if(player.position.z<-20)then
					player.position.x=-15
					player.position.y=0
					player.position.z=2
				end
			end
		end
		
	end
	

	function class:EdgeCheck(player)
		--if(true)then return true end
	
		---------------------------------------------------------------
		--OUT OF BOUNDS CHECK
		---------------------------------------------------------------
		if(true)then return true end --!!!
		
		if(not player)then return true end
		
		local distsqr=player.position.x*player.position.x+player.position.y*player.position.y
		local dist=math.sqrt(distsqr)
		--print("Player dist:",dist)
		local maxradius=41
		if(dist>maxradius)then
			return false
		end			
	
		return true
	end
	
	function class:DebuffCheck()
		local scenario=self.scenario		
		if(not scenario.player)then return end
		if(scenario.pausemode)then return end
		if(not scenario.debuffsactive)then return end
		local player=scenario.player		
		if(player:IsDeadInGame() or player.dead)then return end	
		local playerdebuff=scenario.guiddebuffs[player.paddedguid]
		if(not playerdebuff) then playerdebuff="X" end
	
		for k,v in pairs(scenario.multiplayer.allplayers) do
			local target=v
			--print("!")
			if(player~=target)then
				--print("?")
				local targetguid=target.paddedguid
				if(targetguid)then
					if(scenario.reportedcollisionlist[player.paddedguid]==nil or scenario.reportedcollisionlist[targetguid]==nil)then					
						local relevant=false				
						local targetdebuff=scenario.guiddebuffs[target.paddedguid]
						if(not targetdebuff)then targetdebuff="X" end					
					
						if((playerdebuff=="1" or playerdebuff=="2")and(targetdebuff=="1" or targetdebuff=="2"))then relevant=true end
						
						if(XPRACTICE_SAVEDATA.THEJAILER.mythic==true)then
							if(playerdebuff=="1" or playerdebuff=="2")then relevant=true end
							if(targetdebuff=="1" or targetdebuff=="2")then relevant=true end					
						end
						
						if(relevant)then
							local xdist=player.position.x-target.position.x
							local ydist=player.position.y-target.position.y
							local distsqr=xdist*xdist+ydist*ydist
							local radius=XPRACTICE.THEJAILER2.Config.DebuffCollisionRadius
							if(distsqr<=radius*radius)then
								local hit=false
								local clear=false
								if(XPRACTICE_SAVEDATA.THEJAILER.mythic==true)then
									if(playerdebuff=="X" or targetdebuff=="X")then
										-- if we're here, we already know the other debuff is either "1" or "2"
										hit=true
									end
								end
								if(playerdebuff==targetdebuff)then
									hit=true
								else
									clear=true
								end
								if(hit)then
									local survived=false
									if(scenario:AttemptKillPlayer(player)==false)then 
										survived=true
									end
									local args={}			
									tinsert(args,targetguid)
									tinsert(args,survived)
									tinsert(args,scenario.timeelapsed)
									self.scenario.multiplayer:FormatAndSendCustom("COLLISION",unpack(args))
									scenario.reportedcollisionlist[player.paddedguid]=true
									scenario.reportedcollisionlist[targetguid]=true																				
								end
								if(clear)then
									local args={}
									tinsert(args,targetguid)
									tinsert(args,scenario.timeelapsed)
									self.scenario.multiplayer:FormatAndSendCustom("CLEAR",unpack(args))
									scenario.reportedcollisionlist[player.paddedguid]=true
									scenario.reportedcollisionlist[targetguid]=true
								end
							end
						end
					end
				end
			end
		end		

		-- local auras=player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.THEJAILER2.Aura_PallyBubble)
		-- if(#auras>0)then
			-- -- do nothing; player is immune			
		-- else
		-- end
	end
	
	-- function class:ExplosionCollisionDetection(sourceplayer)
		-- local scenario=self.scenario		
		-- if(not scenario.player)then return end
		-- local player=scenario.player
		-- if(player:IsDeadInGame() or player.dead)then return end	
		-- local xdist=player.position.x-sourceplayer.position.x
		-- local ydist=player.position.y-sourceplayer.position.y
		-- local distsqr=xdist*xdist+ydist*ydist
		-- local radius=XPRACTICE.THEJAILER2.Config.DebuffExplosionRadius
		-- if(distsqr<=radius*radius)then	
			-- if(scenario:AttemptKillPlayer(player))then
				-- --print("ExplosionCollisionDetection:",self.scenario.totaldeaths)
				-- local args={}
				-- tinsert(args,scenario.timeelapsed)
				-- self.scenario.multiplayer:FormatAndSendCustom("DEAD_OTHEREXPLOSION",unpack(args))
			-- end										
		-- end
	
	-- end
	
end